*** /tmp/,RCSt1022166	Wed Jul 25 13:44:40 1990
--- sh4.c	Thu Jul 12 01:03:24 1990
***************
*** 1,5 ****
  #define Extern extern
- #include <signal.h>
- #include <errno.h>
- #include <setjmp.h>
  #include <sys/types.h>
--- 1,2 ----
***************
*** 7,8 ****
--- 4,9 ----
  #include <sys/dir.h>
+ #include <limits.h>
+ #include <signal.h>
+ #include <errno.h>
+ #include <setjmp.h>
  #include "sh.h"
***************
*** 32,33 ****
--- 33,35 ----
  	char **wp;
+ 	char **wf;
  	jmp_buf ev;
***************
*** 34,36 ****
  
- 	inword++;
  	wp = NULL;
--- 36,37 ----
***************
*** 37,44 ****
  	wb = NULL;
  	if (newenv(setjmp(errpt = ev)) == 0) {
! 		wb = addword((char *)0, wb); /* space for shell name, if command file */
! 		while (expand(*ap++, &wb, f))
! 			;
  		wb = addword((char *)0, wb);
! 		wp = getwords(wb) + 1;
  		quitenv();
--- 38,55 ----
  	wb = NULL;
+ 	wf = NULL;
  	if (newenv(setjmp(errpt = ev)) == 0) {
! 		while (*ap && isassign(*ap))
! 			expand(*ap++, &wb, f & ~DOGLOB);
! 		if (flag['k']) {
! 			for (wf = ap; *wf; wf++) {
! 				if (isassign(*wf))
! 					expand(*wf, &wb, f & ~DOGLOB);
! 			}
! 		}
! 		for (wb = addword((char *)0, wb); *ap; ap++) {
! 			if (!flag['k'] || !isassign(*ap))
! 				expand(*ap, &wb, f & ~DOKEY);
! 		}
  		wb = addword((char *)0, wb);
! 		wp = getwords(wb);
  		quitenv();
***************
*** 46,49 ****
  		gflg = 1;
! 	inword--;
! 	return(gflg? NULL: wp);
  }
--- 57,59 ----
  		gflg = 1;
! 	return(gflg? (char **)NULL: wp);
  }
***************
*** 52,56 ****
   * Make the exported environment from the exported
!  * names in the dictionary.  Keyword assignments
!  * ought to be taken from wp (the list of words on the command line)
!  * but aren't, yet. Until then: ARGSUSED
   */
--- 62,65 ----
   * Make the exported environment from the exported
!  * names in the dictionary. Keyword assignments
!  * will already have been done.
   */
***************
*** 57,60 ****
  char **
! makenv(wp)
! char **wp;
  {
--- 66,69 ----
  char **
! makenv()
! 
  {
***************
*** 78,80 ****
  
- 	inword++;
  	wb = NULL;
--- 87,88 ----
***************
*** 86,88 ****
  		cp = NULL;
- 	inword--;
  	return(cp);
--- 94,95 ----
***************
*** 136,137 ****
--- 143,145 ----
  	register char *sp;
+ 	int scanequals, foundequals;
  
***************
*** 138,139 ****
--- 146,149 ----
  	sp = e.linep;
+ 	scanequals = f & DOKEY;
+ 	foundequals = 0;
  
***************
*** 140,142 ****
  loop:
! 	switch (c = subgetc('"', 0)) {
  	case 0:
--- 150,152 ----
  loop:
! 	switch (c = subgetc('"', foundequals)) {
  	case 0:
***************
*** 154,155 ****
--- 164,166 ----
  	case '\'':
+ 		scanequals = 0;
  		if (INSUB())
***************
*** 166,169 ****
  	unget(c);
  	for (;;) {
! 		c = subgetc('"', 0);
  		if (c == 0 ||
--- 177,182 ----
  	unget(c);
+ 	if (!letter(c))
+ 		scanequals = 0;
  	for (;;) {
! 		c = subgetc('"', foundequals);
  		if (c == 0 ||
***************
*** 170,174 ****
  		    f & DOBLANK && any(c, ifs->value) ||
! 		    !INSUB() && any(c, "\"'`")) {
  			unget(c);
! 			if (any(c, "\"'`"))
  				goto loop;
--- 183,188 ----
  		    f & DOBLANK && any(c, ifs->value) ||
! 		    !INSUB() && any(c, "\"'")) {
! 		        scanequals = 0;
  			unget(c);
! 			if (any(c, "\"'"))
  				goto loop;
***************
*** 176,177 ****
--- 190,198 ----
  		}
+ 		if (scanequals)
+ 			if (c == '=') {
+ 				foundequals = 1;
+ 				scanequals  = 0;
+ 			}
+ 			else if (!letnum(c))
+ 				scanequals = 0;
  		*e.linep++ = c;
***************
*** 307,309 ****
  	e.linep = s;
! 	PUSHIO(aword, dolp, strchar);
  	return(0);
--- 328,330 ----
  	e.linep = s;
! 	PUSHIO(aword, dolp, quoted ? qstrchar : strchar);
  	return(0);
***************
*** 322,324 ****
  
! 	for (cp = e.iop->arg.aword; *cp != '`'; cp++)
  		if (*cp == 0) {
--- 343,345 ----
  
! 	for (cp = e.iop->argp->aword; *cp != '`'; cp++)
  		if (*cp == 0) {
***************
*** 335,337 ****
  	if (i != 0) {
! 		e.iop->arg.aword = ++cp;
  		close(pf[1]);
--- 356,358 ----
  	if (i != 0) {
! 		e.iop->argp->aword = ++cp;
  		close(pf[1]);
***************
*** 342,344 ****
  	/* allow trapped signals */
! 	for (i=0; i<NSIG; i++)
  		if (ourtrap[i] && signal(i, SIG_IGN) != SIG_IGN)
--- 363,365 ----
  	/* allow trapped signals */
! 	for (i=0; i<=_NSIG; i++)
  		if (ourtrap[i] && signal(i, SIG_IGN) != SIG_IGN)
***************
*** 350,352 ****
  	flag['n'] = 0;
! 	cp = strsave(e.iop->arg.aword, 0);
  	areanum = 1;
--- 371,373 ----
  	flag['n'] = 0;
! 	cp = strsave(e.iop->argp->aword, 0);
  	areanum = 1;
***************
*** 446,448 ****
  	struct direct ent[NDENT];
! 	char dname[DIRSIZ+1];
  	struct stat dbuf;
--- 467,469 ----
  	struct direct ent[NDENT];
! 	char dname[NAME_MAX+1];
  	struct stat dbuf;
***************
*** 465,467 ****
  	}
! 	dname[DIRSIZ] = '\0';
  	while ((n = read(dn, (char *)ent, sizeof(ent))) >= sizeof(*ent)) {
--- 486,488 ----
  	}
! 	dname[NAME_MAX] = '\0';
  	while ((n = read(dn, (char *)ent, sizeof(ent))) >= sizeof(*ent)) {
***************
*** 471,475 ****
  				continue;
! 			strncpy(dname, ent[j].d_name, DIRSIZ);
! 			if (dname[0] == '.' &&
! 			    (dname[1] == '\0' || dname[1] == '.' && dname[2] == '\0'))
  				if (*gp != '.')
--- 492,495 ----
  				continue;
! 			strncpy(dname, ent[j].d_name, NAME_MAX);
! 			if (dname[0] == '.')
  				if (*gp != '.')
***************
*** 476,478 ****
  					continue;
! 			for(k=0; k<DIRSIZ; k++)
  				if (any(dname[k], spcl))
--- 496,498 ----
  					continue;
! 			for(k=0; k<NAME_MAX; k++)
  				if (any(dname[k], spcl))
***************
*** 590,592 ****
  	if (wb == NULL)
! 		return(NULL);
  	if (wb->w_nword == 0) {
--- 610,612 ----
  	if (wb == NULL)
! 		return((char **)NULL);
  	if (wb->w_nword == 0) {
***************
*** 593,595 ****
  		DELETE(wb);
! 		return(NULL);
  	}
--- 613,615 ----
  		DELETE(wb);
! 		return((char **)NULL);
  	}
